import json

data = []
for chunk in open("input").read().split("\n\n"):
    data.append([json.loads(x) for x in chunk.splitlines(False)])

def cmp(a, b):
    if type(a) == int and type(b) == int:
        return (a > b) - (a < b)
    if type(a) == list and type(b) == int:
        b = [b]
    elif type(a) == int and type(b) == list:
        a = [a]
        
    for x, y in zip(a,b):
        r = cmp(x,y)
        if r != 0:
            return r
    return cmp(len(a),len(b))

#print(data)

t = 0
for i,(a,b) in enumerate(data):
    #print("<" if less(a,b) else ">=")
    if cmp(a,b) < 0:
        t += i + 1
print(t)


import functools

big = [e for x in data for e in x]
big.append([[2]])
big.append([[6]])
big.sort(key=functools.cmp_to_key(cmp))

i1 = big.index([[2]]) + 1
i2 = big.index([[6]]) + 1

print(i1*i2)
